package WebFlow.ATD;


import WebFlow.*;
import WebFlow.submitJob.*;
import WebFlow.xml.*;
import org.w3c.dom.*;
import com.ibm.xml.parser.ExternalID;
import com.ibm.xml.parser.Parser;
import com.ibm.xml.parser.TXDocument;
import com.ibm.xml.parser.TXText;
import com.ibm.xml.parser.TXElement;
import com.ibm.xml.parser.DTD;
import java.io.*;
import java.util.Vector;

 public class XmlATDImpl extends BeanContextChildSupport
                           implements WebFlow.ATD.XmlATDOperations {

 String msg_;
 org.omg.CORBA.Object peer;
 private Parser parser;
 private Document doc;
 private String FileName,Fname;
    public XmlATDImpl(org.omg.CORBA.Object peer, String msg)
	throws WebFlow.NullPointerException {
    
        super(peer); 
        this.peer = peer;
        msg_ = msg;
    }

    public void test() {
        System.out.println("Xml ATD is up");
    }

    public boolean newATD(String FileName){

      boolean result=true;

      this.FileName = FileName;
      /* strip out .xml extension and use it as the document name */
      Fname=FileName;
      int idx= Fname.indexOf(".xml");
      String Name=Fname.substring(0, idx);               

      try{
      doc = 
      (Document)Class.forName("com.ibm.xml.parser.TXDocument").newInstance();
      
       ((TXDocument)doc).setVersion("1.0");

       Element root = doc.createElement("TaskDescriptor"); 
      
       Element item= doc.createElement("TaskName");
       item.setAttribute("name",Name);
       item.appendChild(doc.createTextNode("Parssim code"));
       root.appendChild(item);

       DTD dt=((TXDocument)doc).createDTD
                     ("TaskDescriptor", new ExternalID("descriptorDTD.dtd"));

      ((TXDocument)doc).appendChild(dt);
       doc.appendChild(root);

      }
      catch (Exception e) {
        System.out.println(e+ " while newATD");
        result=false;
      }
      return result;
    }

       
    public void addApplication(String application) {
       Node root = doc.getDocumentElement();
       Element item= doc.createElement("application");
       item.setAttribute("descriptor",Fname);
       root.appendChild(item);
    }

    public void addConnection(String src, String dst, String event, 
                              String method){

       Node root = doc.getDocumentElement();
       Element item= doc.createElement("connection");
           
       Element itemChild=doc.createElement("output");
       itemChild.setAttribute("application",src);   
       itemChild.setAttribute("event",event);
       item.appendChild(itemChild);

       itemChild=doc.createElement("input");
       itemChild.setAttribute("application",dst);    
       itemChild.setAttribute("method",method);
       item.appendChild(itemChild);
       root.appendChild(item);
    }

    public boolean SaveAsXML() {
        boolean status = true;
	try {
		Node root = doc.getDocumentElement();
		((TXDocument)doc).printWithFormat(new FileWriter(FileName));
	}
	catch (Exception e){
	  System.out.println(e+" while SaveAsXml");
          status=false;
	}

	return status;
    }
   public boolean instantiateParser(String FileName) {
        boolean status = false;
        try {
            File infile = new File(FileName);
            if(infile.exists()) {
            FileInputStream is = new FileInputStream(FileName);
            parser = new Parser(FileName);
            doc = parser.readStream(is);
            if(parser.getNumberOfErrors() > 0) {
            System.out.println("Sorry, the xml document has errors");
               //System.exit(1);
              }
              else {
               status = true;
	      }
	    }
	    else {
               System.out.println("Sorry, file "+FileName+" does not exist");
	    }
	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
       return status;
    }
   
    public String[] getApplications() {
       String[] result=null;
       Node root = doc.getDocumentElement();
       Vector a = getAllTags(root,"application");
       int n = a.size();
       if(n>0) {
          result = new String[n];
          for(int i=0; i<n; i++) {
            result[i]=((Element)a.elementAt(i)).getAttribute("descriptor"); 
	  }
       }
       else {
          result = new String[1];
          result[0]="none";
       }
       return result; 
    }  

    public String[] getConnections() {
       String[] result=null;
       Node root = doc.getDocumentElement();
       Vector a = getAllTags(root,"connection");
       int n = a.size();
       if(n>0) {
          result = new String[4*n];
          for(int i=0; i<n; i++) {
            int k=4*i;
            Node out=findFirstTag((Node)a.elementAt(i),"output"); 
            result[k]=((Element)out).getAttribute("application"); 
            result[k+1]=((Element)out).getAttribute("event"); 
            Node in=findFirstTag((Node)a.elementAt(i),"input"); 
            result[k+2]=((Element)in).getAttribute("application"); 
            result[k+3]=((Element)in).getAttribute("method"); 
	  }
       }
       else {
          result = new String[1];
          result[0]="none";
       }
       return result; 
    }  

   
  private  String getAttributeValue(Node node, String tag, String name) {
        String value="";
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                   if(ch.getNodeName().equals(tag)) {
                    value=((Element)ch).getAttribute(name);
                    break;
                 }
              }
          }
      return value;
    };

   public String GetADFileName(){
        System.out.println("function entered.......");
        Vector vlist = new Vector();
        Vector pilist = new Vector();
        String FileName="";
        try{
        Node root=doc.getDocumentElement();
        Vector rtags =getAllTags(root, "TaskName");
	int rn = rtags.size();
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
				FileName =((Element)ch).getAttribute("descriptor");
                 System.out.println(i+" "+FileName);
				}		 //find the file's name in descriptor.
	}
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }	
        return FileName;  

};

  public  String getCommandLine(String Applicationname, String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      String command="";
      String path=""; 
      String exec="";
      try {
	Node root=doc.getDocumentElement();
	Node rootC1 = findFirstTag(root, "Command"); //to find the Command node
	command = ((Element)rootC1).getAttribute("exec")+" "+((Element)rootC1).getAttribute("path") ;
	System.out.println("the commandline is : "+ command);
      }//end of try.
      catch (Exception e) {
	System.out.println(e);
	e.printStackTrace();
      }
      return command;
  };
 


  private Node findTagWithAttribute(Node node, String tag,
                                      String attr, String value) { 
        Node result=null;
        for(Node ch = node.getFirstChild(); ch!=null;ch = ch.getNextSibling())          {            
           if(ch instanceof Element) {
                  if(ch.getNodeName().equals(tag)) {
                    if(((Element)ch).getAttribute(attr).equals(value)){
                           result=ch;
                           break;
                        }
                 }
              }
          }
    return result;
    }; 

   private Vector getAllTags(Node node, String tag) {
        Vector result=new Vector();
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
	      if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    result.addElement(ch);
		 }
	      }
	  }
      return result;
    }

 private Node findFirstTag(Node node, String tag) 
    {
        Node result=null;
        Node chroot= node;
        Node ch=null;
    while (chroot!=null)	 
    {
      
      if(chroot instanceof Element) 
      {
	if(chroot.getNodeName().equals(tag))
	  {
	   result=chroot;
	   return result;
	  }
	else {
	  ch = chroot.getFirstChild();
	  if(ch!=null)
		    {   
	      return result=findFirstTag(ch, tag); 
	    }
	  else  chroot=chroot.getNextSibling();
	}	
      }
      else  chroot=chroot.getNextSibling();
    }
             return result; 
    };


		    
  public void submitTaskE(submitJobEvent e) {
     String fileName = e.getFileName(); 
     String User = e.getUser();
     boolean status = submitTask(fileName,User);
     if(status==false) {
        System.out.println("submitting "+fileName+" failed");
        // fireEvent(failureEvent,e,?,?);
     }
     else {
        System.out.println("submitting "+fileName+" completed");
        // fireEvent(successEvent,e,?,?);
     }   
  }

  public boolean submitTask(String fileName, String User) {
     boolean result=true;
     if(instantiateParser(fileName)) {
        String[] appl = getApplications();
        String[] conn = getConnections();
        if(conn.length>0 & !(conn[0].equals("none"))) {
	  System.out.println("connections not yet implemented");
	  result=false;
          for(int i=0;i<conn.length;i++) {
             System.out.println(i+" "+conn[i]);
	  }
	}
        else {
          if(appl.length<1) {
             System.out.println("Ooops! no application defined in ATD");
             result=false;
	  }
          else {
             if(appl.length<1) {
               System.out.println("Ooops! cannot sumit more than one job");
               result=false;
	     }
             else {
               String ADfile = appl[0]; 
               System.out.println("ADfile="+ADfile); 
               System.out.println("User="+User); 
               jobRequestEventImpl jrEvent = 
                new jobRequestEventImpl(getBeanContextChildPeer(),ADfile,User);
               System.out.println(jrEvent.getXmlFile());
               fireEvent("JobRequest",jrEvent);
	     }
	  }
	}
     }
     else {
       System.out.println("reading ATD failed :-(");
       result = false;
     }    
     return result;
  };


 public void DescriptorGD(String filename)
   {
        String Fname= filename;
        DTD dtd;
        int idx= Fname.indexOf(".xml");
        String Name=Fname.substring(0, idx);               
     
        try{
	  //       Parser parser;
       String dtdfile="/npac/home/webflow/WEBFLOW/BeanContext_2.2.2/ATD/descriptorDTD.dtd";
       //  InputStream is=(new URL(dtdfile)).openStream();
       FileInputStream is =new FileInputStream(dtdfile);
       parser= new Parser(dtdfile);
       dtd= parser.readDTDStream(is);      

       //creates a Document object;
       Document doc = (Document)Class.forName("com.ibm.xml.parser.TXDocument").newInstance();
      
       //mkaes the "TaskDescriptor" element as the root, and adds it.
       Element root = doc.createElement("Task"); 
      
    
       //Makes the "TaskName" element, and adds it
       Element item= doc.createElement("TaskName");
       item.setAttribute("name",Name);
       item.setAttribute("descriptor",Fname);
       //  item.appendChild(doc.createTextNode("Parssim code"));
       root.appendChild(item);
       
       //Makes the "application" element with an attribute, and adds it.      
       item= doc.createElement("InputPort");
       item.setAttribute("task","Run");
       root.appendChild(item);

       //Makes the "application" element with an attribute, and adds it.      
       item= doc.createElement("OUTputPort");
       item.setAttribute("task","Done");
       root.appendChild(item);

      
      //add the root  
       DTD dt=((TXDocument)doc).createDTD("TASK", new ExternalID("descriptorDTD.dtd"));
      ((TXDocument)doc).appendChild(dt);
       doc.appendChild(root);
      
       // Shows the XML document
       ((TXDocument)doc).setVersion("1.0");
       ((TXDocument)doc).printWithFormat(new FileWriter("ATDtest.xml"));             }
     catch(Exception e)
     {
     e.printStackTrace();
     }
 };
			     

/* 
 public  String getCommandLineOLD(String Applicationname, String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      String command="";
      String path=""; 
      String exec="";
   try {
         Node root=doc.getDocumentElement();
        Node rootC1 = findTagWithAttribute(root,"application","id",Applicationname); 
	Node rootC1 = findFirstTagOLD(root, "Command");
       command = ((Element)rootC1).getAttribute("exec")+" "+((Element)rootC1).getAttribute("path") ;
System.out.println("the commandline is : "+ command);
        if(rootC1!= null)
        { 
            Node ch = findTagWithAttribute(rootC1,"target","id",hostname);
            if(ch != null) 
             {
              if(getAttributeValue(ch,"status","installed").equals("Yes"))
                {
                status=true;
                }
              if(status) {
                  // find node <installed>
                  Node ch1 = findFirstTag(ch,"installed");
                  // executable or a script to be generated?
                  Node Snode = findFirstTag(ch1,"script");
                  if(Snode == null) {
                     // retrieve CmdLine
                     Snode = findFirstTag(ch1,"CmdLine");
                     if (Snode == null) {
                       System.out.println("Oops, no CmdLine node!");
                     }
                     else {
                       Node ch2 = findFirstTag(Snode,"Command");
                       if (ch2 == null) {
                         System.out.println("Oops, no Command node!");
                         }
                       else{
                         path = ((Element)ch2).getAttribute("path");
                         exec = ((Element)ch2).getAttribute("exec"); 
                         command=exec+" "+path;  
                           }
                     }
                  }
                   else {
                    // there is a script to be generated
                    
                   Node Mnode = findFirstTag(Snode,"module");
                     if(Mnode != null) {
                     rsl  = "script:";
                     rsl += "name="+((Element)Mnode).getAttribute("name");
                     rsl += " idl="+((Element)Mnode).getAttribute("idl");
                     rsl += "class="+((Element)Mnode).getAttribute("class");
		     }
                     else {
                     System.out.println("something fishy... no module tag");
                    }
		   }//else for Snode
              }
              else {
               System.out.println("Sorry, this application is not installed "+" on "+hostname);
              }//else for status
             }//end of if?
	   }// end of application id check
	 else{
             System.out.println("Sorry, Here have no the application name  "+Applicationname);
          }
	
}//end of try.
   catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
        }
return command;
    };
 */

}













